zoukankan      html  css  js  c++  java
  • HDU 1885

    Key Task

    Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 1474    Accepted Submission(s): 605


    Problem Description
    The Czech Technical University is rather old — you already know that it celebrates 300 years of its existence in 2007. Some of the university buildings are old as well. And the navigation in old buildings can sometimes be a little bit tricky, because of strange long corridors that fork and join at absolutely unexpected places.

    The result is that some first-graders have often di?culties finding the right way to their classes. Therefore, the Student Union has developed a computer game to help the students to practice their orientation skills. The goal of the game is to find the way out of a labyrinth. Your task is to write a verification software that solves this game.

    The labyrinth is a 2-dimensional grid of squares, each square is either free or filled with a wall. Some of the free squares may contain doors or keys. There are four di?erent types of keys and doors: blue, yellow, red, and green. Each key can open only doors of the same color.

    You can move between adjacent free squares vertically or horizontally, diagonal movement is not allowed. You may not go across walls and you cannot leave the labyrinth area. If a square contains a door, you may go there only if you have stepped on a square with an appropriate key before.
     

    Input
    The input consists of several maps. Each map begins with a line containing two integer numbers R and C (1 ≤ R, C ≤ 100) specifying the map size. Then there are R lines each containing C characters. Each character is one of the following:



    Note that it is allowed to have
  • more than one exit,
  • no exit at all,
  • more doors and/or keys of the same color, and
  • keys without corresponding doors and vice versa.

    You may assume that the marker of your position (“*”) will appear exactly once in every map.

    There is one blank line after each map. The input is terminated by two zeros in place of the map size.
 

Output
For each map, print one line containing the sentence “Escape possible in S steps.”, where S is the smallest possible number of step to reach any of the exits. If no exit can be reached, output the string “The poor student is trapped!” instead.

One step is defined as a movement between two adjacent cells. Grabbing a key or unlocking a door does not count as a step.
 

Sample Input
1 10 *........X 1 3 *#X 3 20 #################### #XY.gBr.*.Rb.G.GG.y# #################### 0 0
 

Sample Output
Escape possible in 9 steps. The poor student is trapped! Escape possible in 45 steps.
 

Source


#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<queue>
#include<stack>
#include<vector>
#include<set>
#include<map>

#define L(x) (x<<1)
#define R(x) (x<<1|1)
#define MID(x,y) ((x+y)>>1)

#define eps 1e-8
typedef __int64 ll;

using namespace std;

#define INF 0x3f3f3f3f
#define N 105

struct stud{
  int x,y,step;
  int va;
};

queue<stud>q;

int n,m;
int step[4][2]={1,0,-1,0,0,1,0,-1};
int vis[1<<4][N][N];
int sx,sy;
char c[N][N];

char get(char c)
{
    if(c=='R') return 'A';
    if(c=='r') return 'a';
    if(c=='B') return 'B';
    if(c=='b') return 'b';
    if(c=='Y') return 'C';
    if(c=='y') return 'c';
    if(c=='G') return 'D';
    if(c=='g') return 'd';
    if(c=='#') return '#';
    if(c=='*') return '*';
    if(c=='.') return '.';
    return 'X';
}

inline bool judge(int x,int y)
{
    if(x>=0&&x<n&&y>=0&&y<m)
        return true;
    return false;
}

void bfs()
{
    int i,j;
    stud cur,next;
    while(!q.empty()) q.pop();
    cur.x=sx;
    cur.y=sy;
    cur.step=0;
    cur.va=0;
    memset(vis,0,sizeof(vis));
    vis[0][sx][sy]=1;
    q.push(cur);
    while(!q.empty())
    {
       cur=q.front();
       q.pop();
       if(c[cur.x][cur.y]=='X')
       {
           printf("Escape possible in %d steps.
",cur.step);
           return ;
       }
       for(i=0;i<4;i++)
       {
           int xx=cur.x+step[i][0];
           int yy=cur.y+step[i][1];
           if(!judge(xx,yy)) continue;
           if(c[xx][yy]=='#') continue;
           if(vis[cur.va][xx][yy]) continue;
           if(c[xx][yy]>='A'&&c[xx][yy]<='D'&&!(cur.va&(1<<(c[xx][yy]-'A')))) continue;
           next.x=xx;
           next.y=yy;
           next.step=cur.step+1;
           next.va=cur.va;
           if(c[xx][yy]>='a'&&c[xx][yy]<='d')
            next.va|=1<<(c[xx][yy]-'a');
            vis[next.va][xx][yy]=1;
            q.push(next);
       }
    }
   printf("The poor student is trapped!
");
}
int main()
{
   int i,j;
   while(scanf("%d%d",&n,&m),n+m)
   {
      for(i=0;i<n;i++)
        scanf("%s",c[i]);
      for(i=0;i<n;i++)
        for(j=0;j<m;j++)
          if(c[i][j]=='*')
      {
          sx=i;
          sy=j;
      }
      else
          c[i][j]=get(c[i][j]);

//      for(i=0;i<n;i++)
//         printf("%s
",c[i]);
      bfs();
   }
  return 0;
}




查看全文
  • 相关阅读:
    写代码的方法与思考
    改变文件上传input file类型的外观
    关于HTML Button点击自动刷新页面的问题解决
    使用 git push 出现error setting certificate verify locations问题记录
    flex使用学习
    jQuery.fn.extend()
    jQuery extend()
    作用域
    私有变量
    模仿块级作用域
  • 原文地址:https://www.cnblogs.com/lytwajue/p/7088083.html
  • Copyright © 2011-2022 走看看